<?php
/**
* Plugin zum Verwalten eines Gruppenkalenders
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


class DateObject {
	
	var $von = 0;
	var $bis = 0;
	var $x = 0;
	var $y = 0;
	var $hoehe = 0;
	var $weite = 0;
	var $color = 'grau';
	var $title = '';
	var $content = '';
	var $ort = '';
	var $user_id = '';
	var $mkdate = 0;
	var $chdate = null;
	var $ch_user_id = null;
	var $date_type = 0;	
	var $delta = 0;
	var $termin_id = '';
	var $range_id = '';
	var $write_perm = 'autor';
	var $write_perm_group = '';
	var $fulltime = 0;
	var $serie_id = '';
	var $overlapp = FALSE;
	var $src = 'group_cal';

	var $config;

	function DateObject() {
	}

	function loadFromArray($arr) {
		$this->termin_id = $arr['termin_id'];
		$this->range_id = $arr['range_id'];
		$this->von = $arr['date'];
		$this->bis = $arr['end_time'];
		$this->ort = $arr['ort'];
		$this->user_id = $arr['user_id'];
		$this->mkdate = $arr['mkdate'];
		$this->chdate = $arr['chdate'];
		$this->ch_user_id = $arr['ch_user_id'];
		$this->title = $arr['title'];
		$this->color = $arr['color'];
		$this->date_type = $arr['date_type'];
		$this->content = $arr['content'];
		$this->delta = $arr['delta'];
		$this->write_perm = $arr['write_perm'];
		$this->write_perm_group = $arr['write_perm_group'];
		$this->fulltime = $arr['fulltime'];
		$this->serie_id = $arr['serie_id'];
		$this->src = $arr['src'];

		$this->config = new GkConfig($GLOBALS['auth']->auth['uid'], $this->range_id);

		switch ($this->src) {
			case 'sem_cal' : 
				$this->color = $this->config->get('sem_date_color');
				break;
			case 'tv_cal' : 
				$this->color = $this->config->get('tv_date_color');
				break;
			case 'pers_cal' :
				$this->color = $this->config->get('cal_date_color');
				break;
			default : break;
		}
	}

	function load($termin_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT t.*, 'group_cal' src FROM gk_termine t WHERE t.termin_id='%s'", $termin_id);
		if ($db->next_record())
			$this->loadFromArray($db->Record);
		$this->setDateType(1);
	}

	function save() {
		$db = new DB_Seminar();
		$db->queryf("UPDATE gk_termine SET date=%d, end_time=%d, ort='%s', chdate=UNIX_TIMESTAMP(), ch_user_id='%s', title='%s', content='%s', color='%s', write_perm='%s', write_perm_group='%s', fulltime=%d  WHERE termin_id='%s' AND range_id='%s'",
			$this->von, $this->bis, $this->ort, $GLOBALS['auth']->auth['uid'], $this->title, 
			$this->content, $this->color, $this->write_perm, $this->write_perm_group, 
			$this->fulltime, $this->termin_id, $this->range_id);
	}

	function insert() {
		$db = new DB_Seminar();
		$db->queryf("INSERT INTO gk_termine (termin_id, range_id, user_id, title, content, date, end_time, ort, mkdate, color, write_perm, write_perm_group, fulltime, serie_id) VALUES ('%s','%s','%s','%s','%s',%d,%d,'%s', UNIX_TIMESTAMP(), '%s', '%s', '%s', %d, '%s')",
			$this->termin_id, $this->range_id, $this->user_id, $this->title, $this->content, 
			$this->von, $this->bis, $this->ort, $this->color, $this->write_perm, 
			$this->write_perm_group, $this->fulltime, $this->serie_id);
	}

	function delete() {
		$db = new DB_Seminar();
		$db->queryf("DELETE FROM gk_termine WHERE termin_id='%s' AND range_id='%s'",$this->termin_id, $this->range_id);
	}

	function getTerminId() { 
		return $this->termin_id;
	}
	function getRangeId() {
		return $this->range_id;
	}
	function getVon() {
		return $this->von;
	}
	function getBis() {
		return $this->bis;
	}
	function getX() {
		return $this->x;
	}
	function getY() {
		return $this->y;
	}
	function getHoehe() {
		return $this->hoehe;
	}
	function getWeite() {
		return $this->weite;
	}
	function getColor() {
		return $this->color;
	}
	function getTitle() {
		return $this->title;
	}
	function getContent() {
		return $this->content;
	}
	function getOrt() {
		return $this->ort;
	}
	function getUserId() {
		return $this->user_id;
	}
	function getDateType() {
		return $this->date_type;
	}
	function getDelta() {
		return $this->delta;
	}
	function getWritePerm() {
		return $this->write_perm;
	}
	function getWritePermGroup() {
		return $this->write_perm_group;
	}
	function getFulltime() {
		return $this->fulltime;
	}
	function getSerieId() {
		return $this->serie_id;
	}
	function getOverlapp() {
		return $this->overlapp;
	}
	function getMkdate() {
		return $this->mkdate;
	}
	function getChdate() {
		return $this->chdate;
	}
	function getChUserId() {
		return $this->ch_user_id;
	}
	function getSrc() {
		return $this->src;
	}

	function setTerminId($s) {
		$this->termin_id = $s;
	}
	function setRangeId($s) {
		$this->range_id = $s;
	}
	function setVon($s) {
		$this->von = $s;
	}
	function setBis($s) {
		$this->bis = $s;
	}
	function setX($s) {
		$this->x = $s;
	}
	function setY($s) {
		$this->y = $s;
	}
	function setHoehe($s) {
		$this->hoehe = $s;
	}
	function setWeite($s) {
		$this->weite = $s;
	}
	function setColor($s) {
		$this->color = $s;
	}
	function setOrt($s) {
		$this->ort = $s;
	}
	function setTitle($s) {
		$this->title = $s;
	}
	function setContent($s) {
		$this->content = $s;
	}
	function setUserId($s) {
		$this->user_id = $s;
	}
	function setDateType($s) {
		$this->date_type = $s;
	}
	function setDelta($s) {
		$this->delta = $s;
	}
	function setWritePerm($s) {
		$this->write_perm = $s;
	}
	function setWritePermGroup($s) {
		$this->write_perm_group = $s;
	}
	function setFulltime($s) {
		$this->fulltime = $s;
	}
	function setOverlapp($s){
		$this->overlapp = $s;
	}
	function setSerieId($s) {
		$this->serie_id = $s;
	}

}

?>
