<?php
/**
* Plugin zum Verwalten eines Gruppenkalenders
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


class DownloadManager {

	var $content;
	var $content_type;
	var $content_disposition;
	var $fname;
	
	function DownloadManager($content, $fname, $ctype = "application/octet-stream", $cdispo = "attachment") {
		$this->content_type = $ctype;
		$this->content_disposition = $cdispo;
		$this->content = $content;
		$this->fname = $fname;
	}


	function download() {
		ob_start();
		header("Expires: Mon, 12 Dec 2001 08:00:00 GMT");
		header("Last-Modified: " . gmdate ("D, d M Y H:i:s") . " GMT");
		if ($_SERVER['HTTPS'] == "on"){
			header("Pragma: public");
			header("Cache-Control: private");
		} else {
			header("Pragma: no-cache");
			header("Cache-Control: no-store, no-cache, must-revalidate");   // HTTP/1.1
		}
		header("Cache-Control: post-check=0, pre-check=0", false);
		header("Content-Type: ".$this->content_type."; name=\"".$this->fname."\"");
		header("Content-Description: File Transfer");
		header("Content-Transfer-Encoding: binary");
		header("Accept-Ranges: bytes");
		header("Content-Length: ".strlen($this->content));
		header("Content-Disposition: ".$this->content_disposition."; filename=\"".$this->fname."\"");
		ob_end_flush();

		echo $this->content;
        }
}

?>
